import datetime

from etl.common.PathsAndTable import PathsAndTable
from service.plt_service import update_trans_transfer_progress
from utils.log.trans_log import trans_print


class ClearData(object):

    def __init__(self, pathsAndTable: PathsAndTable):
        self.pathsAndTable = pathsAndTable

    def clean_data(self):
        self.pathsAndTable.delete_tmp_files()
        if self.pathsAndTable.save_db:
            self.pathsAndTable.delete_batch_db()
        self.pathsAndTable.delete_batch_files()

    def run(self):
        trans_print("开始清理数据,临时文件夹:", self.pathsAndTable.get_tmp_path())
        begin = datetime.datetime.now()
        self.clean_data()
        update_trans_transfer_progress(self.pathsAndTable.batch_no, self.pathsAndTable.read_type, 5,
                                       self.pathsAndTable.save_db)
        trans_print("清理数据结束,耗时:", datetime.datetime.now() - begin)
